--- /usr/local/jail/usr/src/sys/dev/usb/ukbd.c	Mon Mar  1 21:56:02 2004
+++ ukbd.c	Fri Jun 10 14:34:05 2005
@@ -195,6 +195,22 @@
 	USB_ATTACH_SUCCESS_RETURN;
 }
 
+
+static void
+usbd_add_device_detach_event(device_t self)
+{
+        struct usb_event ue;
+
+        bzero(&ue, sizeof(ue));
+
+        strncpy(ue.u.ue_device.udi_devnames[0],
+                device_get_nameunit(self), USB_MAX_DEVNAMELEN);
+        ue.u.ue_device.udi_devnames[0][USB_MAX_DEVNAMELEN - 1] = '\0';
+
+        usb_add_event(USB_EVENT_DEVICE_DETACH, &ue);
+}
+
+
 int
 ukbd_detach(device_t self)
 {
@@ -219,6 +235,8 @@
 		return error;
 
 	DPRINTF(("%s: disconnected\n", USBDEVNAME(self)));
+        
+        usbd_add_device_detach_event(self);
 
 	return (0);
 }
